// DEFINE SOME CONSTANTS
float DotSizeX=0;
float DotSizeZ=0;
const int cGoldAmtDwarven=1000;
const int cGoldAmtTiny=1500;
const int cGoldAmtSmall=3000;
const int cGoldAmtLarge=6000;

const int cVeryShort=3;
const int cShort=10;
const int cMedium=20;
const int cLong=40;
const int cVeryLong=80;

float MapScaler = 10;

// GLOBALS ***************************************************
int MapSkin = 1;
int SeaOrLand = 1;  // SEA=1 LAND=0
float SeaLevel = -6;
int WaterOnMap = 0;
int failCount=0;
float pct=1;
float ResourceScaler = 0;

// DECLARE OUR CONSTRAINTS GLOBAL SO WE CAN USE IN FUNCTIONS
// Keep Things Off The Map Edges
int avoidMapEdgesVeryShort=cVeryShort;
int avoidMapEdgesShort=cShort;
int avoidMapEdgesMedium=cMedium;
int avoidMapEdgesLong=cLong;
int avoidMapEdgesVeryLong=cVeryLong;

// Used For Various Land Masses
int avoidLandAreaShort=cShort;
int avoidLandAreaMedium=cMedium;
int avoidLandAreaLong=cLong;

// Used For Various Cliffs/Gorges
int avoidCliffsVeryShort=cVeryShort;
int avoidCliffsShort=cShort;
int avoidCliffsMedium=cMedium;
int avoidCliffsLong=cLong;

// Animals
int avoidAnimalsShort=cShort;
int avoidAnimalsMedium=cMedium;
int avoidAnimalsLong=cLong;

// Player Areas Constraint
int avoidPlayerAreasVeryShort=cVeryShort;
int avoidPlayerAreasShort=cShort;
int avoidPlayerAreasMedium=cMedium;
int avoidPlayerAreasLong=cLong;
int avoidPlayerAreasVeryLong=140;

// Lakes Constraint
int avoidLakesVeryShort=cVeryShort;
int avoidLakesShort=cShort;
int avoidLakesMedium=cMedium;
int avoidLakesLong=cLong;
int avoidLakesVeryLong=cVeryLong;

// Town Centers constraint.
int avoidTownCentersShort=cShort;
int avoidTownCentersMedium=cMedium;
int avoidTownCentersLong=cLong;

// Building constraints - Used For Additoinal Settlements
int avoidBuildingsVeryShort=cVeryShort;
int avoidBuildingsShort=cShort;
int avoidBuildingsMedium=cMedium;
int avoidBuildingsLong=cLong;
int avoidBuildingsVeryLong=cVeryLong;

// Gold
int avoidGoldShort=cShort;
int avoidGoldMedium=cMedium;
int avoidGoldLong=cLong;
int avoidGoldVeryLong=cVeryLong;

// Relics
int avoidRelicShort=cShort;
int avoidRelicMedium=cMedium;
int avoidRelicLong=cLong;
int avoidRelicVeryLong=cVeryLong;

// Avoid impassable land
int avoidImpassableLandVeryShort=cVeryShort;
int avoidImpassableLandShort=cShort;
int avoidImpassableLandMedium=cMedium;
int avoidImpassableLandLong=cLong;

// Forests
int avoidForestVeryShort=cVeryShort;
int avoidForestShort=cShort;
int avoidForestMedium=cMedium;
int avoidForestLong=cLong;

// Avoid Water
int avoidWaterVeryShort=2;
int avoidWaterShort=cShort;
int avoidWaterMedium=cMedium;
int avoidWaterLong=cLong;

// Near To Water
int nearShoreLineVeryShort=cVeryShort;
int nearShoreLineShort=cShort;
int nearShoreLineMedium=cMedium;
int nearShoreLineLong=cLong;

// Near Land
int nearLandVeryShort=cVeryShort;
int nearLandShort=cShort;
int nearLandMedium=cMedium;
int nearLandLong=cLong;

// Avoid All Objects
int avoidAllVeryShort=cVeryShort;
int avoidAllShort=cShort;
int avoidAllMedium=cMedium;
int avoidAllLong=cLong;

// Classes
int classTownCenters=0;
int classPlayer=0;
int classCliffs=0;
int classLand=0;
int classForest=0;
int classLakes=0;
int classAnimals=0;
int classAlaska=0;
int classAlaskaShoreLine=0;
int classAppalachians=0;
int classCanada=0;
int classCanadaShoreLine=0;
int classCaribbean=0;
int classCascades=0;
int classGreatLakes=0;
int classGreatSaltLake=0;
int classGreenLand=0;
int classGreenLandShoreLine=0;
int classHawaii=0;
int classLakeAthabasca=0;
int classLakeGreatBear=0;
int classLakeGreatSlave=0;
int classLakeUnk=0;
int classLakeWinnipeg=0;
int classMexico=0;
int classMexicoShoreLine=0;
int classMississippi=0;
int classRockies=0;
int classSeirraNevadas=0;
int classUSA=0;
int classUSAShoreLine=0;

int classVolcano=0;


int avoidAlaskaVeryShort=0;
int avoidAppalachiansVeryShort=0;
int avoidCanadaVeryShort=0;
int avoidCaribbeanVeryShort=0;
int avoidCascadesVeryShort=0;
int avoidGreatLakesVeryShort=0;
int avoidGreatSaltLakeVeryShort=0;
int avoidGreenLandVeryShort=0;
int avoidHawaiiVeryShort=0;
int avoidLakeAthabascaVeryShort=0;
int avoidLakeGreatBearVeryShort=0;
int avoidLakeGreatSlaveVeryShort=0;
int avoidLakeUnkVeryShort=0;
int avoidLakeWinnipegVeryShort=0;
int avoidMexicoVeryShort=0;
int avoidMississippiVeryShort=0;
int avoidRockiesVeryShort=0;
int avoidSeirraNevadasVeryShort=0;
int avoidUSAVeryShort=0;



float iifF(bool cond=true, float val1=0, float val2=0) {
   if (cond==true) return(val1);
   else return(val2);
}

/* SKINNING FUNCTIONS  ************************************/
float GetAnimalCount(string Animal="") {
   if (Animal=="Aurochs") return (rmRandInt(1,2)); //(400.0));
   if (Animal=="Baboon") return (rmRandInt(6,12)); //(80.0));
   if (Animal=="Berry Bush") return (rmRandInt(6,12)); //(100.0));
   if (Animal=="Boar") return (rmRandInt(2,4)); //(300.0));
   if (Animal=="Caribou") return (rmRandInt(2,5)); //(150.0));
   if (Animal=="Chicken") return (rmRandInt(7,10)); //(75.0));
   if (Animal=="Cow") return (rmRandInt(1,2)); //(75.0));
   if (Animal=="Crocodile") return (rmRandInt(2,3)); //(200.0));
   if (Animal=="Crowned Crane") return (rmRandInt(5,10)); //(100.0));
   if (Animal=="Deer") return (rmRandInt(3,5)); //(150.0));
   if (Animal=="Elephant") return (rmRandInt(1,3)); //(750.0));
   if (Animal=="Elk") return (rmRandInt(3,5)); //(150.0));
   if (Animal=="Fish - Mahi") return (rmRandInt(1,2)); //(100.0));
   if (Animal=="Fish - Perch") return (rmRandInt(1,2)); //(100.0));
   if (Animal=="Fish - Salmon") return (rmRandInt(1,2)); //(100.0));
   if (Animal=="Gazelle") return (rmRandInt(4,6)); //(100.0));
   if (Animal=="Giraffe") return (rmRandInt(2,3)); //(300.0));
   if (Animal=="Goat") return (rmRandInt(1,2)); //(50.0));
   if (Animal=="Hippo") return (rmRandInt(1,3)); //(400.0));
   if (Animal=="Monkey") return (rmRandInt(6,12)); //(100.0));
   if (Animal=="Pig") return (rmRandInt(1,2)); //(50.0));
   if (Animal=="Rhinocerous") return (rmRandInt(1,3)); //(500.0));
   if (Animal=="Walrus") return (rmRandInt(2,4)); //(100.0));
   if (Animal=="Water Buffalo") return (rmRandInt(1,3)); //(400.0));
   if (Animal=="Zebra") return (rmRandInt(2,5)); //(200.0));
   // THESE ARE HITPOINTS
   if (Animal=="Ape Of Set") return (rmRandInt(1,1)); //(45.0));
   if (Animal=="Bear") return (rmRandInt(1,3)); //(90.0));
   if (Animal=="Hyena") return (rmRandInt(1,3)); //(80.0));
   if (Animal=="Hyena Of Set") return (rmRandInt(1,1)); //(45.0));
   if (Animal=="Lion") return (rmRandInt(1,3)); //(60.0));
   if (Animal=="Polar Bear") return (rmRandInt(1,3)); //(90.0));
   if (Animal=="Rhinocerous Of Set") return (rmRandInt(2,3)); //(180.0));
   if (Animal=="Shade of erebus") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Serpent") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Wolf") return (rmRandInt(2,3)); //(45.0));
   rmEchoInfo("Animal not found="+Animal);
   return(1000.0);
}
string GetAnimalType(int HerdHuntFishPred=0) {
   // RANDOMLY SELECT AN ANIMAL BASED ON MapSkin
   int ThisSkin=MapSkin;
   int rand=0;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (HerdHuntFishPred==1) { // LOOKING FOR HERDABLE TYPE
      if (ThisSkin==1) {// WINTER HERDABLE
         rand = rmRandInt(1,5);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Pig");
         else if (rand==3) return("goat");
         else if (rand==4) return("Cow");
         else if (rand==5) return("Crowned Crane");
      }
      if (ThisSkin==2) {// SPRING HERDABLE
         rand = rmRandInt(1,5);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
         else if (rand==4) return("Crowned Crane");
         else if (rand==5) return("Chicken");
      }
      if (ThisSkin==3) {// SUMMER HERDABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Cow");
         else if (rand==4) return("Cow");
      }
      if (ThisSkin==4) {// FALL HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
      }
      if (ThisSkin==5) {// MORDOR HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Pig");
      }
   } else if (HerdHuntFishPred==2) { // LOOKING FOR HUNTABLE
      if (ThisSkin==1 || ThisSkin==4) {// WINTER/FALL HUNTABLE
         rand = rmRandInt(1,4+WaterOnMap); // A 1 IF SEA TO POSSIBLY PLACE A WATER TYPE ANIMAL
         if (rand==1) return("Caribou");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Deer");
         else if (rand==4) return("Elk");
      }
      if (ThisSkin==2) {// SPRING HUNTS
         rand = rmRandInt(1,4+WaterOnMap);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Hippo");
         else if (rand==3) return("Monkey");
         else if (rand==4) return("Baboon");
      }
      if (ThisSkin==3) {// SUMMER HUNTS
         rand = rmRandInt(1,4+WaterOnMap);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Boar");
         else if (rand==4) return("Aurochs");
      }
      if (ThisSkin==5) {// MORDOR HUNTABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Baboon");
         else if (rand==2) return("Boar");
         else if (rand==3) return("Rhinocerous");
      }
      rand = rmRandInt(1,2); // IF A SEA MAP, THEN PLACE A WATER TYPE ANIMAL
      if (rand==1) return("Walrus");
      else if (rand==2) return("Water Buffalo");
   } else if (HerdHuntFishPred==3) { // LOOKING FOR FISHABLE
      rand = rmRandInt(1,3);
      if (rand==1) return("Fish - Mahi");
      else if (rand==2) return("Fish - Perch");
      else if (rand==3) return("Fish - Salmon");
   } else if (HerdHuntFishPred==4) { // LOOKING FOR PREDATORS
      rand = rmRandInt(1,500);
      if (rand==1) return("Ape Of Set"); // THROW A MONKEY WRENCH AT EM FROM TIME TO TIME
      if (ThisSkin==1 || ThisSkin==4) {// WINTER/FALL PREDATORS
         rand = rmRandInt(1,2);
         if (rand==1) return("Polar Bear");
         else if (rand==2) return("Wolf");
      }
      if (ThisSkin==2) {// SPRING PREDATORS
         rand = rmRandInt(1,3+WaterOnMap);
         if (rand==1) return("Hyena");
         else if (rand==2) return("Lion");
         else if (rand==3) return("Serpent");
      }
      if (ThisSkin==3) {// SUMMER PREDATORS
         rand = rmRandInt(1,4+WaterOnMap);
         if (rand==1) return("Wolf");
         else if (rand==2) return("Wolf");
         else if (rand==3) return("Serpent");
         else if (rand==4) return("Bear");
      }
      if (ThisSkin==5) {// MORDOR PREDATORS
         rand = rmRandInt(1,5);
         if (rand==1) return("Serpent");
         else if (rand==2) return("Shade of erebus");
         else if (rand==3) return("Ape Of Set");
         else if (rand==4) return("Hyena Of Set");
         else if (rand==5) return("Rhinoceros Of Set");
      }
      return("Crocodile"); // IF WATER MAP AND NONE SELECTED
   }
}


int CreateAnimals(string ObjName="", int HerdHuntFishPred=0, int MinDist=0, int MaxDist=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string Animal = GetAnimalType(HerdHuntFishPred);
   float NumToPlace = GetAnimalCount(Animal);
//   NumToPlace = iifF(NumToPlace<2,2,NumToPlace); // ALWAYS PLACE AT LEAST TWO
   rmEchoInfo("Placing "+NumToPlace+" "+Animal);
   int id=rmCreateObjectDef("Animal"+Animal+ObjName);
   rmAddObjectDefItem(id, Animal, NumToPlace, 3.0 * HerdHuntFishPred);
   rmSetObjectDefMinDistance(id, MinDist);
   rmSetObjectDefMaxDistance(id, MaxDist);
   if (AddToClass>0) rmAddObjectDefToClass(id, AddToClass);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
   rmAddObjectDefConstraint(id, avoidForestShort);
   rmAddObjectDefConstraint(id, avoidAnimalsMedium);

   if (HerdHuntFishPred==1) {
      rmAddObjectDefConstraint(id, avoidBuildingsShort);
      rmAddObjectDefConstraint(id, avoidMapEdgesMedium);
   } else if (HerdHuntFishPred==2) {
      rmAddObjectDefConstraint(id, avoidBuildingsMedium);
      rmAddObjectDefConstraint(id, avoidMapEdgesMedium);
   } else if (HerdHuntFishPred==3) {
      rmAddObjectDefConstraint(id, avoidMapEdgesShort);

   } else if (HerdHuntFishPred==4) {
      rmAddObjectDefConstraint(id, avoidBuildingsMedium);
   }
   if (Animal=="Walrus" || Animal=="Water Buffalo" || Animal=="Crocodile") {
      rmAddObjectDefConstraint(id, nearShoreLineVeryShort);
   } else if (HerdHuntFishPred!=3) { // NOT FISH, AVOID WATERS EDGE
      rmAddObjectDefConstraint(id, avoidWaterVeryShort);
   }
   return(id);
}

string GetBirdType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (rmRandInt(1,10)==1 && MapSkin==5) return("Flying Purple Hippo"); // Whee! - Only MORDER
   if (rmRandInt(1,10)==1) return("Harpy"); // Controlable
   else if (ThisSkin==1) return("Vulture"); // WINTER
   else if (ThisSkin==2) return("Hawk"); // SPRING
   else if (ThisSkin==3) return("Hawk"); // SUMMER
   else if (ThisSkin==4) return("Vulture"); // FALL
   else if (ThisSkin==5) return("Harpy"); // MORDER
}

string GetSeaType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("North Atlantic Ocean"); // WINTER
   else if (ThisSkin==2) return("Red Sea"); // SPRING
   else if (ThisSkin==3) return("mediterranean sea"); // summa
   else if (ThisSkin==4) return("Norwegian Sea");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}
string GetLakeType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("Norse River"); // WINTER
   else if (ThisSkin==2) return("Savannah Water Hole"); // SPRING
   else if (ThisSkin==3) return("Greek River"); // SUMMER
   else if (ThisSkin==4) return("Norse River");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}

string GetLandType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("SnowGrass75"); // WINTER
   else if (ThisSkin==2) return("SavannahA"); // SPRING
   else if (ThisSkin==3) return("GrassA"); // SUMMER
   else if (ThisSkin==4) return("SnowGrass25"); // FALL
   else if (ThisSkin==5) return("ForestFloorDeadPine"); // MORDOR
}

string GetTreeType(int ForestOrTreeType=0) {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ForestOrTreeType==1) { // LOOKING FOR A FOREST TYPE
      if (ThisSkin==1) { // WINTER
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Snow Pine Forest");
         else if (ThisSkin==2) return("Mixed Pine Forest");
      }
      else if (ThisSkin==2) {// SPRING
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Savannah Forest");
         else if (ThisSkin==2) return("Palm Forest");
      } else if (ThisSkin==3) { // SUMMER
         ThisSkin=rmRandInt(1,3);
         if (ThisSkin==1) return("Mixed Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
         else if (ThisSkin==3) return("Oak Forest");
      }
      else if (ThisSkin==4) { // FALL
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Autumn Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
      }
      else if (ThisSkin==5) return("Hades Forest"); // MORDOR
   } else { // INDIVIDUAL TREE
      if (ThisSkin==1) return("Pine Snow"); // WINTER
      else if (ThisSkin==2) {
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Savannah Tree");
         else if (ThisSkin==2) return("Palm");
      } else if (ThisSkin==3) {
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Oak Tree");
         else if (ThisSkin==2) return("Pine");
         else if (ThisSkin==3) return("Palm");
      }
      else if (ThisSkin==4) {
         ThisSkin=rmRandInt(1,2); // FALL
         if (ThisSkin==1) return("Oak Autumn");
         else if (ThisSkin==2) return("Pine");
      }
      else if (ThisSkin==5) return("Pine Dead"); // MORDOR
   }
}


string GetCliffType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("Norse"); // WINTER
   else if (ThisSkin==2) return("Egyptian"); // SPRING
   else if (ThisSkin==3) return("Greek"); // SUMMER
   else if (ThisSkin==4) return("Norse"); // FALL
   else if (ThisSkin==5) return("Hades"); // MORDOR
}

string GetRockType(string Size="") {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) {
      if (rmRandInt(1,10)>1) return("Rock Granite "+Size); // WINTER
      else return ("Rock River Icy");
   }
   else if (ThisSkin==2 || ThisSkin==3) return("Rock Sandstone "+Size); // SPRING/SUMMER
   else if (ThisSkin==4) return("Rock Limestone "+Size); // FALL
   else if (ThisSkin==5) return("Stalagmite"); // MORDOR
   /* Look into these: Rock Cliff, Rock River Grassy, Rock River Icy, Rock River Sandy, Rock Snow, Rock Symbols */
}

string GetRoadType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("NorseRoadA"); // WINTER
   else if (ThisSkin==2) return("GreekRoadA"); // SPRING
   else if (ThisSkin==3) { // SUMMER
      if (rmRandInt(2,2)==1) return("CityTileA");
      return("CityTileAtlantis");
   }
   else if (ThisSkin==4) return("NorseRoadA"); // FALL
   else if (ThisSkin==5) return("UnderWaterRockC"); // MORDOR
}

string GetWaterPlant(int Lake=0) {
   int WhichPlant=rmRandInt(1,6);
   if (Lake==1) WhichPlant=rmRandInt(1,5);
   if (WhichPlant==1) return("water lilly");
   else if (WhichPlant==2) return("papyrus");
   else if (WhichPlant==3) return("Water decoration");
   else if (WhichPlant==4) return("Water Reeds");
   else if (WhichPlant==5) return("Hawksbill"); // I Know
   else if (WhichPlant==6) return("Seaweed");
}

string GetBigFish() {
   int ThisSkin= rmRandInt(1,3);
   if (ThisSkin==1) return("Orca");
   else if (ThisSkin==2) return("Whale");
   else if (ThisSkin==3) return("Shark");
}

void LayerTerrain(int id=0, float Width=6) {
   // WIDTH IN METERS!! - Layers starting at 0 go from outer edge toward area center
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"SnowA",0, Width * .33);
      rmAddAreaTerrainLayer(id,"SnowGrass50",Width * .33,Width * .66);
      rmAddAreaTerrainLayer(id,"SnowGrass25",Width * .66,Width);
   } else if (ThisSkin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"SavannahC",0, Width * .25);
      rmAddAreaTerrainLayer(id,"SavannahD", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SavannahC", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"SavannahB", Width * .75,Width);
   } else if (ThisSkin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"GrassDirt25",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffGreekB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"GrassDirt50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"GrassDirt25", Width * .75,Width);
   } else if (ThisSkin==4) { // FALL
      rmAddAreaTerrainLayer(id,"SnowGrass25",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SnowGrass50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .75,Width);
   } else if (ThisSkin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0,Width * .5);
      rmAddAreaTerrainLayer(id,"HadesBuildable2",Width * .5,Width);
   }
}

void SetMainLandType(int id=0, int LayerWidth=0, int Height=2, string ForceType="") {
   if (ForceType=="") {
      rmSetAreaTerrainType(id,GetLandType());
      LayerTerrain(id, LayerWidth);
   } else {
      rmSetAreaTerrainType(id,ForceType);
   }
   rmSetAreaSmoothDistance(id,6);
   rmSetAreaBaseHeight(id,Height);
}

/* AREA FUNCTIONS  ************************************/
int CreateAreaAtXZ(string ObjName="", float AtX=.5, float AtZ=.5, float WidthX=0, float WidthZ=0, float HeightBlend=2, float Coherence=1, int ParentArea=0) {
   int id = 0;
   if (ParentArea>0) id = rmCreateArea(ObjName, ParentArea);
   else id = rmCreateArea(ObjName);
   rmSetAreaHeightBlend(id,HeightBlend);
   if (AtX>-1 && AtZ>-1) rmSetAreaLocation(id,AtX,AtZ);
   rmSetAreaSize(id,WidthX,WidthZ);
   rmSetAreaCoherence(id,Coherence);
   return (id);
}

void BlobulateArea(int id=0, int MinBlobs=0, int MinBlobDist=0,  int MaxBlobs=0, int MaxBlobDist=0) {
   rmSetAreaMinBlobs(id,MinBlobs);
   rmSetAreaMaxBlobs(id,MaxBlobs);
   rmSetAreaMinBlobDistance(id, MinBlobDist);
   rmSetAreaMaxBlobDistance(id, MaxBlobDist);
}

void LandArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, int AddToClass=0, int ParentArea=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   float ThisHeight=0;
   for(i=0; <numAreas) {
      int id = CreateAreaAtXZ(ObjName+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthX), 2, 0, ParentArea);
      rmSetAreaWarnFailure(id, false);
      ThisHeight=rmRandFloat(MinHeight, MaxHeight);
      rmSetAreaSmoothDistance(id, 10);
      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      rmSetAreaTerrainType(id,GetLandType());
      //rmSetAreaTerrainType(id,"Black");
//      LayerTerrain(id, WidthX/5);
//      rmSetAreaBaseHeight(id,ThisHeight);
      SetMainLandType(id, 6, ThisHeight);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}


void CliffArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   failCount=0;
   float NumEdges=rmRandFloat(1,4);
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+i, -1, -1, rmXMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 1, 0);
      rmSetAreaWarnFailure(id, false);
      BlobulateArea(id, 3, rmRandInt(3, 5),  rmRandInt(10, 15), rmRandInt(15, 40));
      rmSetAreaSmoothDistance(id, 10);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      rmSetAreaCliffType(id, GetCliffType());
      rmSetAreaCliffEdge(id, NumEdges, 1.0/NumEdges, 0.1, 1.0, 0);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, rmRandInt(MinHeight,MaxHeight), 1.0, 1.0);
      LayerTerrain(id, 6);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}

void ForestArea(string ObjName="", int numAreas=0, float WidthX=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0, int ParentArea=0) {
   failCount=0;
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+"ImpassForest"+i, -1, -1, rmXMetersToFraction(WidthX), rmZMetersToFraction(WidthX), 2, 0);
      rmSetAreaWarnFailure(id, false);
      rmSetAreaForestType(id,GetTreeType(1));
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}

void BeautifyWater(string ObjName="", int AddFish=0,  int Embellish=0, int Class=0) {
   if (AddFish>0) { // ADD SOME FISH TO THE WATER
      int fishid = rmCreateObjectDef(ObjName+"fish");
      rmAddObjectDefItem(fishid,GetAnimalType(3),1,0.0);
      for (i=1;<=AddFish) rmPlaceObjectDefInRandomAreaOfClass(fishid, 0, Class, 1);
   }
   if (Embellish>0) { // ADD SOME PLANT LIFE TO THE WATER
      int plantid = rmCreateObjectDef(ObjName+"plant");
      rmAddObjectDefItem(plantid,GetWaterPlant(),3,1.0); // 3 per
      for (i=1;<=Embellish) rmPlaceObjectDefInRandomAreaOfClass(plantid, 0, Class, 1);
   }
}

float Clamp(float val=0) {
   if (val<0)       return(0.0);
   else if (val>1)  return(1.0);
   else             return (val);
}

void SetPloinkTerrain(int id=0, int AddToClass1=0, int AddToClass2=0, int LandLakeCliff=1, int Height=0, int Size=2) {
   pct = pct-0.01;
   rmSetStatusText("",pct);
   if (LandLakeCliff==1) {
      rmSetAreaTerrainType(id,GetLandType());
      rmSetAreaBaseHeight(id,Height);
      rmSetAreaCoherence(id,1);
      LayerTerrain(id, rmRandInt(3,6));
   } else if (LandLakeCliff==2) {
      rmSetAreaWaterType(id, GetLakeType());
      rmSetAreaBaseHeight(id,Height);
      rmSetAreaCoherence(id,1);
   } else if (LandLakeCliff==3) {
      float NumEdges=rmRandFloat(2,8);
      NumEdges=Size-1;
      if (NumEdges>8) NumEdges=8;
      rmSetAreaCliffType(id, GetCliffType());
      rmSetAreaCliffEdge(id, NumEdges, rmRandFloat(.8,.9)/NumEdges);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, Height, 1.0, .5);
      rmSetAreaCoherence(id,0);
   } else if (LandLakeCliff==4) {
      rmSetAreaCliffType(id, GetCliffType());
      NumEdges = rmRandInt(5,8);
      rmSetAreaCliffEdge(id, NumEdges, .8/NumEdges);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, Height, 1.0, .5);
      rmSetAreaCoherence(id,0);
   } else if (LandLakeCliff==5) {
      rmSetAreaTerrainType(id,"ForestFloorDeadPine");
      rmSetAreaBaseHeight(id,Height);
      rmSetAreaCoherence(id,0);
      //LayerVolcanic(id, 6);
   }
   rmSetAreaSmoothDistance(id,6);
   if (AddToClass1>0) rmAddAreaToClass(id, AddToClass1);
   if (AddToClass2>0) rmAddAreaToClass(id, AddToClass2);
   rmAddAreaToClass(id, classLand);
}

int PloinkLine2(string ObjName="",int i=0,int j=0, int i2=0, int j2=0, int Length=0, int Height=0, int LandLakeCliff=1, int AddToClass1=0, int AddToClass2=0, float DotScaler=1.0) {
   float thisAtX = rmXTilesToFraction(i * MapScaler);
   float thisAtZ = rmZTilesToFraction(j * MapScaler);
   float thisAt2X = rmXTilesToFraction(i2 * MapScaler);
   float thisAt2Z = rmZTilesToFraction(j2 * MapScaler);
   float thisLength = rmXMetersToFraction(.43) * Length * DotScaler;
   int id = CreateAreaAtXZ(ObjName+"_"+i+"_"+j+"_"+i2+"_"+j2, thisAtX, thisAtZ, thisLength, thisLength, 2, .5);
   SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff, Height, Length);
   rmAddAreaInfluenceSegment(id, thisAtX, thisAtZ, thisAt2X, thisAt2Z);
   return (id);
}

int PloinkLine(string ObjName="",int i=0,int j=0, int j2=0, int Height=0, int LandLakeCliff=1, int AddToClass1=0, int AddToClass2=0, float DotScaler=1.0) {
   float thisAtX = rmXTilesToFraction(i * MapScaler);
   float thisAtZ = rmZTilesToFraction(j * MapScaler);
   int Length = (j2-j)+1;
   float thisLength = rmZTilesToFraction(Length * MapScaler);
   int id = CreateAreaAtXZ(ObjName+"_"+i+"_"+j, thisAtX, thisAtZ, rmXMetersToFraction(.43) * Length * DotScaler, rmXMetersToFraction(.43) * Length * DotScaler, 2, 1);
   SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff, Height);
   rmAddAreaInfluenceSegment(id, thisAtX, thisAtZ, thisAtX, thisAtZ+thisLength);
   return (id);
}

int Ploink(string ObjName="",int i=0,int j=0, int Height=0, int LandLakeCliff=1, int AddToClass1=0, int AddToClass2=0, float DotScaler=1.0, int Pixel1=0, int Pixel2=0, int Pixel3=0, int Pixel4=0) {
   float thisDotSizeX = DotSizeX * DotScaler;
   float thisDotSizeZ = DotSizeZ * DotScaler;
   float thisAtX = rmXTilesToFraction(i * MapScaler);
   float thisAtZ = rmZTilesToFraction(j * MapScaler);
   int id=0;
   if (Pixel1+Pixel2+Pixel3+Pixel4==0) { // FULL PLOINK
      id = CreateAreaAtXZ(ObjName+"_"+i+"_"+j, thisAtX, thisAtZ, thisDotSizeX, thisDotSizeZ, 2, 1);
      SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff,Height);
   } else { // 4 pixel ploink
      thisDotSizeX = thisDotSizeX/3;
      thisDotSizeZ = thisDotSizeZ/3;
      int HeightAdj=4;
      if (LandLakeCliff==3) HeightAdj=0;
      if (Pixel1==1) {
         thisAtX = rmXTilesToFraction(i * MapScaler);
         thisAtZ = rmZTilesToFraction(j * MapScaler);
         id = CreateAreaAtXZ(ObjName+"p1_"+i+"_"+j, thisAtX, thisAtZ, thisDotSizeX, thisDotSizeZ, 2, 1);
         SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff,Height+HeightAdj);
      }
      if (Pixel2==1) {
         thisAtX = rmXTilesToFraction((i * 2+1) * MapScaler/2);
         thisAtZ = rmZTilesToFraction((j * 2+0) * MapScaler/2);
         id = CreateAreaAtXZ(ObjName+"p2_"+i+"_"+j, thisAtX, thisAtZ, thisDotSizeX, thisDotSizeZ, 2, 1);
         SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff,Height+HeightAdj);
      }
      if (Pixel3==1) {
         thisAtX = rmXTilesToFraction((i * 2+0) * MapScaler/2);
         thisAtZ = rmZTilesToFraction((j * 2+1) * MapScaler/2);
         id = CreateAreaAtXZ(ObjName+"p3_"+i+"_"+j, thisAtX, thisAtZ, thisDotSizeX, thisDotSizeZ, 2, 1);
         SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff,Height+HeightAdj);
      }
      if (Pixel4==1) {
         thisAtX = rmXTilesToFraction((i * 2+1) * MapScaler/2);
         thisAtZ = rmZTilesToFraction((j * 2+1) * MapScaler/2);
         id = CreateAreaAtXZ(ObjName+"p4_"+i+"_"+j, thisAtX, thisAtZ, thisDotSizeX, thisDotSizeZ, 2, 1);
         SetPloinkTerrain(id, AddToClass1, AddToClass2, LandLakeCliff,Height+HeightAdj);
      }
   }
   return (id);
}

void KeepObjectInArea(int id=0,int AreaClassId=0) {
   if (AreaClassId!=classAlaska) rmAddObjectDefConstraint(id, avoidAlaskaVeryShort);
   if (AreaClassId!=classCanada) rmAddObjectDefConstraint(id, avoidCanadaVeryShort);
   if (AreaClassId!=classGreenLand) rmAddObjectDefConstraint(id, avoidGreenLandVeryShort);
   if (AreaClassId!=classHawaii) rmAddObjectDefConstraint(id, avoidHawaiiVeryShort);
   if (AreaClassId!=classMexico) rmAddObjectDefConstraint(id, avoidMexicoVeryShort);
   if (AreaClassId!=classUSA) rmAddObjectDefConstraint(id, avoidUSAVeryShort);
}

void KeepAreaInArea(int id=0,int AreaClassId=0,int AreaObject=0) {
   if (AreaClassId!=classAlaska) rmAddAreaConstraint(id, avoidAlaskaVeryShort);
   if (AreaClassId!=classCanada) rmAddAreaConstraint(id, avoidCanadaVeryShort);
   if (AreaClassId!=classGreenLand) rmAddAreaConstraint(id, avoidGreenLandVeryShort);
   if (AreaClassId!=classHawaii) rmAddAreaConstraint(id, avoidHawaiiVeryShort);
   if (AreaClassId!=classMexico) rmAddAreaConstraint(id, avoidMexicoVeryShort);
   if (AreaClassId!=classUSA) rmAddAreaConstraint(id, avoidUSAVeryShort);
}

void SetTechStatus(int Player=0, string Tech="0", string OnOff="0") {
   rmAddTriggerEffect("Set Tech Status");
   rmSetTriggerEffectParamInt("PlayerID", Player);
   rmSetTriggerEffectParam("TechID", Tech);
   rmSetTriggerEffectParam("Status", OnOff);
}

void GoldConstr(int id=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   rmAddObjectDefConstraint(id, avoidGoldLong);
   rmAddObjectDefConstraint(id, avoidMapEdgesShort);
   rmAddObjectDefConstraint(id, avoidBuildingsShort);
   rmAddObjectDefConstraint(id, avoidWaterVeryShort);
//   rmAddObjectDefConstraint(id, avoidAllShort);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
}

void PlaceGold(int Amount=0, int MinDist=0, int MaxDist=0, int idTiny=0, int idSmall=0, int idLarge=0) {
   rmSetObjectDefMinDistance(idTiny,MinDist);
   rmSetObjectDefMaxDistance(idTiny,MaxDist);
   rmSetObjectDefMinDistance(idSmall,MinDist);
   rmSetObjectDefMaxDistance(idSmall,MaxDist);
   rmSetObjectDefMinDistance(idLarge,MinDist);
   rmSetObjectDefMaxDistance(idLarge,MaxDist);
   int RemainAmount = Amount;
   int j=0;
   for (i=1; <cNumberPlayers*2) { // ONLY LOOP SO MANY TIMES REGARDLESS OF REQUEST AMOUNT
      if (RemainAmount < cGoldAmtTiny/2) break; // NOT AT LEAST 1/2 A TINY TO PLACE, SO EXIT LOOP
      if (RemainAmount>=cGoldAmtLarge) j = rmRandInt(2,3); // RANDOMLY PICK ANY SIZE
      else if (RemainAmount>=cGoldAmtSmall) j = rmRandInt(1,2); // RANDOMLY PICK SMALLER SIZE
      else j = 1; // IT"S TINY
      if (j == 1) {
         RemainAmount = RemainAmount - cGoldAmtTiny;
         rmPlaceObjectDefPerPlayer(idTiny,false,1);
      } else if (j == 2) {
         RemainAmount = RemainAmount - cGoldAmtSmall;
         rmPlaceObjectDefPerPlayer(idSmall,false,1);
      } else if (j == 3) {
         RemainAmount = RemainAmount - cGoldAmtLarge;
         rmPlaceObjectDefPerPlayer(idLarge,false,1);
      }
   }
}
void CreateGold(int CloseAmount=0, float CloseDist=0, int NearByAmount=0, float NearByDist=0, int FarAmount=0, float FarDist=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   int idTiny = rmCreateObjectDef("GoldTiny");
   rmAddObjectDefItem(idTiny,"Gold Mine Tiny",1,0.0);
   GoldConstr(idTiny, Constraint1, Constraint2, Constraint3, Constraint4);

   int idSmall = rmCreateObjectDef("GoldSmall");
   rmAddObjectDefItem(idSmall,"Gold Mine Small",1,0.0);
   GoldConstr(idSmall, Constraint1, Constraint2, Constraint3, Constraint4);

   int idLarge = rmCreateObjectDef("GoldLarge");
   rmAddObjectDefItem(idLarge,"Gold Mine",1,0.0);
   GoldConstr(idLarge, Constraint1, Constraint2, Constraint3, Constraint4);

   PlaceGold(CloseAmount, 6, CloseDist, idTiny, idSmall, idLarge);
   PlaceGold(NearByAmount, CloseDist, NearByDist, idTiny, idSmall, idLarge);
   PlaceGold(FarAmount, NearByDist, FarDist, idTiny, idSmall, idLarge);
}

void PlacePlayer(int Player=0, float MyAtX=0, float MyAtZ=0) {
   float thisAtX = rmXTilesToFraction(MyAtX * MapScaler);
   float thisAtZ = rmZTilesToFraction(MyAtZ * MapScaler);
   int id = CreateAreaAtXZ("PlayerArea"+Player, thisAtX, thisAtZ, rmZMetersToFraction(5), rmZMetersToFraction(5), 2.0, 1);
   rmBuildArea(id);
   rmSetPlayerArea(Player, id);
   rmPlacePlayer(Player, thisAtX, thisAtZ);
   rmAddAreaToClass(id, classPlayer);
}

void PloinkPlayer(int Player=0, int Slot=0) {
rmEchoInfo("Placed Player "+Player+" into Slot "+Slot);
        if (Slot== 1) PlacePlayer(Player, 34,  2);
   else if (Slot== 2) PlacePlayer(Player, 31,  5);
   else if (Slot== 3) PlacePlayer(Player, 28,  8);
   else if (Slot== 4) PlacePlayer(Player, 25, 11);
   else if (Slot== 5) PlacePlayer(Player, 22, 14);
   else if (Slot== 6) PlacePlayer(Player, 20, 18);
   else if (Slot== 7) PlacePlayer(Player, 17, 19);
   else if (Slot== 8) PlacePlayer(Player, 16, 22);
   else if (Slot== 9) PlacePlayer(Player, 15, 25);
   else if (Slot==10) PlacePlayer(Player, 15, 28);
   else if (Slot==11) PlacePlayer(Player, 13, 31);
   else if (Slot==12) PlacePlayer(Player, 11, 34);
   else if (Slot==13) PlacePlayer(Player,  8, 36);
   else if (Slot==14) PlacePlayer(Player,  5, 38);
   else if (Slot==15) PlacePlayer(Player,  9, 47);//SIDE 2
   else if (Slot==16) PlacePlayer(Player, 13, 48);
   else if (Slot==17) PlacePlayer(Player, 19, 49);
   else if (Slot==18) PlacePlayer(Player, 25, 47);
   else if (Slot==19) PlacePlayer(Player, 37, 40);//28, 42);
   else if (Slot==20) PlacePlayer(Player, 29, 37);
   else if (Slot==21) PlacePlayer(Player, 37, 35);
   else if (Slot==22) PlacePlayer(Player, 37, 31);
   else if (Slot==23) PlacePlayer(Player, 38, 27);
   else if (Slot==24) PlacePlayer(Player, 40, 23);
   else if (Slot==25) PlacePlayer(Player, 37, 24);
   else if (Slot==26) PlacePlayer(Player, 43, 20);
   else if (Slot==27) PlacePlayer(Player, 40, 16);
   else if (Slot==28) PlacePlayer(Player, 41, 12);
   else if (Slot== 0) PlacePlayer(Player, 49, 14);
}
void DisplayMsg(string message="",int timeout=5000) {
   rmAddTriggerEffect("Message");
   rmSetTriggerEffectParamInt("Timeout", timeout, false);
   rmSetTriggerEffectParam("Text",message);
}

void GameEgg(string name="") {
   rmSetStatusText("",0);
   rmCreateTrigger("egg");
   rmSwitchToTrigger(rmTriggerID("egg"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",1);
   DisplayMsg("***** "+name+" ***** ........by.TwentyOneScore@BeerInHand.com........",5000);
   if (rmRandInt(1,5)==1) { // SPOOK EM
      rmAddTriggerEffect("Sound Filename");
      rmSetTriggerEffectParam("Sound", "\dialog\skul062.mp3");
   }
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",rmRandFloat(.1,.4));
   }
   rmSetTriggerPriority(3);
   rmSetTriggerActive(true);
   rmSetTriggerRunImmediately(true);
   rmSetTriggerLoop(false);
}

void AddRocks(int Num=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string type="sprite";
   for (i=1; <=3) {
      if (i==2) type="small";
      else if (i==3) type="big";
      if (Num>0) {
         int id=rmCreateObjectDef("rock "+type);
         rmAddObjectDefItem(id, GetRockType(type), 1, 0.0);
         rmSetObjectDefMinDistance(id, 0.0);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
         if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
         if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
         if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, Num);
      }
   }
}

void RandomTrees() {
   // -------------Define objects
   int idTree1=0;
   int idTree2=0;
   int idTree3=0;
   int idTree4=0;
   idTree1=rmCreateObjectDef("random tree1"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree1, GetTreeType(0), 3, 1);
   idTree2=rmCreateObjectDef("random tree2"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree2, GetTreeType(0), 3, 1);
   idTree3=rmCreateObjectDef("random tree3"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree3, GetTreeType(0), 3, 1);
   idTree4=rmCreateObjectDef("random tree"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree4, GetTreeType(0), 3, 1);

   rmAddObjectDefConstraint(idTree1, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree2, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree3, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree4, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree1, avoidBuildingsMedium);
   rmAddObjectDefConstraint(idTree2, avoidBuildingsMedium);
   rmAddObjectDefConstraint(idTree3, avoidBuildingsMedium);
   rmAddObjectDefConstraint(idTree4, avoidBuildingsMedium);

   rmSetObjectDefMinDistance(idTree1, 15.0);
   rmSetObjectDefMaxDistance(idTree1, 25.0);
   rmSetObjectDefMinDistance(idTree2, 15.0);
   rmSetObjectDefMaxDistance(idTree2, 25.0);
   rmSetObjectDefMinDistance(idTree3, 15.0);
   rmSetObjectDefMaxDistance(idTree3, 25.0);
   rmSetObjectDefMinDistance(idTree4, 15.0);
   rmSetObjectDefMaxDistance(idTree4, 25.0);
   rmPlaceObjectDefPerPlayer(idTree1, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree2, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree3, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree4, false, 7); // FOR THE PLAYER AREAS

   rmSetObjectDefMinDistance(idTree1, 35);
   rmSetObjectDefMaxDistance(idTree1, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree2, 35);
   rmSetObjectDefMaxDistance(idTree2, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree3, 35);
   rmSetObjectDefMaxDistance(idTree3, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree4, 35);
   rmSetObjectDefMaxDistance(idTree4, rmZFractionToMeters(.5));
   rmPlaceObjectDefPerPlayer(idTree1, false, 25);
   rmPlaceObjectDefPerPlayer(idTree2, false, 25);
   rmPlaceObjectDefPerPlayer(idTree3, false, 25);
   rmPlaceObjectDefPerPlayer(idTree4, false, 25);


}

void main(void) {
/* CONSTANTS ************************************/
   SeaOrLand=cMapSize;
   WaterOnMap=SeaOrLand;
   MapSkin=rmRandInt(1,50);
   if (MapSkin!=1) {// 1 in 50 chance of winter
      MapSkin=rmRandInt(1,50);
      if (MapSkin!=2) {// 1 in 50 chance of spring
         MapSkin=rmRandInt(1,30);
         if (MapSkin!=4) {// 1 in 30 chance of fall
            MapSkin=rmRandInt(1,100);
            if (MapSkin!=5) { // 1 in 100 chance of Hades!!
               MapSkin=3; // otherwise, it's summer
            }
         }
      }
   }
   rmSetStatusText("",pct);

   float MyAtX=0;
   float MyAtZ=0;
   int id=0;
   id = cNumberNonGaiaPlayers/3; // force to integer
   MapScaler = 5 + id + iifF(cMapSize==0,0,2);
   ResourceScaler = .5 + .25 * (cNumberPlayers-1) + cMapSize; // range 2 player = 1, 12 player = 3.5, large map add 1
   int mySize = MapScaler * 100;
   rmSetMapSize(mySize,mySize); // METERS
   rmSetSeaLevel(SeaLevel);
   rmSetSeaType(GetSeaType());
   rmTerrainInitialize("Water");

   int LandHeight = SeaLevel+3;
   int LakeHeight = SeaLevel+1;
   int CliffHeight = 7;
   int CliffPeakHeight = 8;
   DotSizeX=rmXMetersToFraction(1)*(.63 + .01 * cNumberPlayers);
   DotSizeZ=rmZMetersToFraction(1)*(.63 + .01 * cNumberPlayers);


   // Define some classes.
   classTownCenters=rmDefineClass("classTownCenters");
   classPlayer=rmDefineClass("classPlayer");
   classCliffs=rmDefineClass("classCliffs");
   classLand=rmDefineClass("classLand");
   classForest=rmDefineClass("classForest");
   classLakes=rmDefineClass("classLakes");
   classAnimals=rmDefineClass("classAnimals");


   // Keep Things Off The Map Edges
   avoidMapEdgesVeryShort=rmCreateBoxConstraint("Avoid Edge Very Short", rmXTilesToFraction(avoidMapEdgesVeryShort), rmZTilesToFraction(avoidMapEdgesVeryShort), 1.0-rmXTilesToFraction(avoidMapEdgesVeryShort), 1.0-rmZTilesToFraction(avoidMapEdgesVeryShort),0.01);
   avoidMapEdgesShort=rmCreateBoxConstraint("Avoid Edge Short", rmXTilesToFraction(avoidMapEdgesShort), rmZTilesToFraction(avoidMapEdgesShort), 1.0-rmXTilesToFraction(avoidMapEdgesShort), 1.0-rmZTilesToFraction(avoidMapEdgesShort),0.01);
   avoidMapEdgesMedium=rmCreateBoxConstraint("Avoid Edge Medium", rmXTilesToFraction(avoidMapEdgesMedium), rmZTilesToFraction(avoidMapEdgesMedium), 1.0-rmXTilesToFraction(avoidMapEdgesMedium), 1.0-rmZTilesToFraction(avoidMapEdgesMedium),0.01);
   avoidMapEdgesLong=rmCreateBoxConstraint("Avoid Edge Long", rmXTilesToFraction(avoidMapEdgesLong), rmZTilesToFraction(avoidMapEdgesLong), 1.0-rmXTilesToFraction(avoidMapEdgesLong), 1.0-rmZTilesToFraction(avoidMapEdgesLong),0.01);
   avoidMapEdgesVeryLong=rmCreateBoxConstraint("Avoid Edge VeryLong", rmXTilesToFraction(avoidMapEdgesVeryLong), rmZTilesToFraction(avoidMapEdgesVeryLong), 1.0-rmXTilesToFraction(avoidMapEdgesVeryLong), 1.0-rmZTilesToFraction(avoidMapEdgesVeryLong),0.01);

      // Used For Various Land Masses
   avoidLandAreaShort=rmCreateClassDistanceConstraint("Avoid Other Land Short", classLand, avoidLandAreaShort);
   avoidLandAreaMedium=rmCreateClassDistanceConstraint("Avoid Other Land Medium", classLand, avoidLandAreaMedium);
   avoidLandAreaLong=rmCreateClassDistanceConstraint("Avoid Other Land Long", classLand, avoidLandAreaLong);

      // Used For Various Cliffs/Gorges
   avoidCliffsVeryShort=rmCreateClassDistanceConstraint("Avoid Cliffs VeryShort", classCliffs, avoidCliffsVeryShort);
   avoidCliffsShort=rmCreateClassDistanceConstraint("Avoid Cliffs Short", classCliffs, avoidCliffsShort);
   avoidCliffsMedium=rmCreateClassDistanceConstraint("Avoid Cliffs Medium", classCliffs, avoidCliffsMedium);
   avoidCliffsLong=rmCreateClassDistanceConstraint("Avoid Cliffs Long", classCliffs, avoidCliffsLong);

      // Animals
   avoidAnimalsShort=rmCreateClassDistanceConstraint("Avoid Other Animals Short", classAnimals, avoidAnimalsShort);
   avoidAnimalsMedium=rmCreateClassDistanceConstraint("Avoid Other Animals Medium", classAnimals, avoidAnimalsMedium);
   avoidAnimalsLong=rmCreateClassDistanceConstraint("Avoid Other Animals Long", classAnimals, avoidAnimalsLong);

      // Player Areas Constraint
   avoidPlayerAreasVeryShort=rmCreateClassDistanceConstraint("Avoid Players Areas VeryShort", classPlayer, avoidPlayerAreasVeryShort);
   avoidPlayerAreasShort=rmCreateClassDistanceConstraint("Avoid Players Areas Short", classPlayer, avoidPlayerAreasShort);
   avoidPlayerAreasMedium=rmCreateClassDistanceConstraint("Avoid Players Areas Medium", classPlayer, avoidPlayerAreasMedium);
   avoidPlayerAreasLong=rmCreateClassDistanceConstraint("Avoid Players Areas Long", classPlayer, avoidPlayerAreasLong);
   avoidPlayerAreasVeryLong=rmCreateClassDistanceConstraint("Avoid Players Areas VeryLong", classPlayer, avoidPlayerAreasVeryLong);

      // Lakes Constraint
   avoidLakesVeryShort=rmCreateClassDistanceConstraint("Avoid Lakes VeryShort", classLakes, avoidLakesVeryShort);
   avoidLakesShort=rmCreateClassDistanceConstraint("Avoid Lakes Short", classLakes, avoidLakesShort);
   avoidLakesMedium=rmCreateClassDistanceConstraint("Avoid Lakes Medium", classLakes, avoidLakesMedium);
   avoidLakesLong=rmCreateClassDistanceConstraint("Avoid Lakes Long", classLakes, avoidLakesLong);
   avoidLakesVeryLong=rmCreateClassDistanceConstraint("Avoid Lakes VeryLong", classLakes, avoidLakesVeryLong);

      // Town Centers constraint.
   avoidTownCentersShort=rmCreateClassDistanceConstraint("avoid TownCenters Short", classTownCenters, avoidTownCentersShort);
   avoidTownCentersMedium=rmCreateClassDistanceConstraint("avoid TownCenters Medium", classTownCenters, avoidTownCentersMedium);
   avoidTownCentersLong=rmCreateClassDistanceConstraint("avoid TownCenters Long", classTownCenters, avoidTownCentersLong);

      // Building constraints - Used For Additional Settlements
   avoidBuildingsVeryShort=rmCreateTypeDistanceConstraint("Avoid Buildings VeryShort", "Building", avoidBuildingsVeryShort);
   avoidBuildingsShort=rmCreateTypeDistanceConstraint("Avoid Buildings Short", "Building", avoidBuildingsShort);
   avoidBuildingsMedium=rmCreateTypeDistanceConstraint("Avoid Buildings Medium", "Building", avoidBuildingsMedium);
   avoidBuildingsLong=rmCreateTypeDistanceConstraint("Avoid Buildings Long", "Building", avoidBuildingsLong);
   avoidBuildingsVeryLong=rmCreateTypeDistanceConstraint("Avoid Buildings VeryLong", "Building", avoidBuildingsVeryLong);

      // Gold
   avoidGoldShort=rmCreateTypeDistanceConstraint("avoid Gold Short", "gold", avoidGoldShort);
   avoidGoldMedium=rmCreateTypeDistanceConstraint("avoid Gold Medium", "gold", avoidGoldMedium);
   avoidGoldLong=rmCreateTypeDistanceConstraint("avoid Gold Long", "gold", avoidGoldLong);
   avoidGoldVeryLong=rmCreateTypeDistanceConstraint("avoid Gold VeryLong", "gold", avoidGoldVeryLong);

      // Relics
   avoidRelicShort=rmCreateTypeDistanceConstraint("avoid Relics Short", "relic", avoidRelicShort);
   avoidRelicMedium=rmCreateTypeDistanceConstraint("avoid Relics Medium", "relic", avoidRelicMedium);
   avoidRelicLong=rmCreateTypeDistanceConstraint("avoid Relics Long", "relic", avoidRelicLong);
   avoidRelicVeryLong=rmCreateTypeDistanceConstraint("avoid Relics VeryLong", "relic", avoidRelicVeryLong);

      // Avoid impassable land
   avoidImpassableLandVeryShort=rmCreateTerrainDistanceConstraint("Avoid Impassable Land VEryShort", "land", false, avoidImpassableLandVeryShort);
   avoidImpassableLandShort=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Short", "land", false, avoidImpassableLandShort);
   avoidImpassableLandMedium=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Medium", "land", false, avoidImpassableLandMedium);
   avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Long", "land", false, avoidImpassableLandLong);

      // Forests
   avoidForestVeryShort=rmCreateClassDistanceConstraint("Avoid Forest VeryShort", classForest, avoidForestVeryShort);
   avoidForestShort=rmCreateClassDistanceConstraint("Avoid Forest Short", classForest, avoidForestShort);
   avoidForestMedium=rmCreateClassDistanceConstraint("Avoid Forest Medium", classForest, avoidForestMedium);
   avoidForestLong=rmCreateClassDistanceConstraint("Avoid Forest Long", classForest, avoidForestLong);

      // Avoid Water
   avoidWaterVeryShort=rmCreateTerrainDistanceConstraint("avoid water very short", "land", false, avoidWaterVeryShort);
   avoidWaterShort=rmCreateTerrainDistanceConstraint("avoid water short", "land", false, avoidWaterShort);
   avoidWaterMedium=rmCreateTerrainDistanceConstraint("avoid water medium", "land", false, avoidWaterMedium);
   avoidWaterLong=rmCreateTerrainDistanceConstraint("avoid water Long", "land", false, avoidWaterLong);

   // Near To Water
   nearShoreLineVeryShort=rmCreateTerrainMaxDistanceConstraint("near shoreline very short", "water", true, nearShoreLineVeryShort);
   nearShoreLineShort=rmCreateTerrainMaxDistanceConstraint("near shoreline short", "water", true, nearShoreLineShort);
   nearShoreLineMedium=rmCreateTerrainMaxDistanceConstraint("near shoreline medium", "water", true, nearShoreLineMedium);
   nearShoreLineLong=rmCreateTerrainMaxDistanceConstraint("near shoreline long", "water", true, nearShoreLineLong);

   // Near To Land
   nearLandVeryShort=rmCreateTerrainMaxDistanceConstraint("near Land very short", "land", true, nearLandVeryShort);
   nearLandShort=rmCreateTerrainMaxDistanceConstraint("near Land short", "land", true, nearLandShort);
   nearLandMedium=rmCreateTerrainMaxDistanceConstraint("near Land medium", "land", true, nearLandMedium);
   nearLandLong=rmCreateTerrainMaxDistanceConstraint("near Land long", "land", true, nearLandLong);

      // Avoid All Objects
   avoidAllVeryShort=rmCreateTypeDistanceConstraint("avoid all very short", "all", avoidAllVeryShort);
   avoidAllShort=rmCreateTypeDistanceConstraint("avoid all short", "all", avoidAllShort);
   avoidAllMedium=rmCreateTypeDistanceConstraint("avoid all medium", "all", avoidAllMedium);
   avoidAllLong=rmCreateTypeDistanceConstraint("avoid all long", "all", avoidAllLong);

   // Keep Off Shore
   int avoidLandShoreLineShort = rmCreateTerrainDistanceConstraint("avoidLandShoreLine", "land", true, cShort);

   rmSetStatusText("",pct);

   PloinkLine("Stretch",0,0, 46, LandHeight, 1, classLand);
   PloinkLine("Stretch",1,0, 46, LandHeight, 1, classLand);
   PloinkLine("Stretch",2,0, 47, LandHeight, 1, classLand);
   PloinkLine("Stretch",3,0, 46, LandHeight, 1, classLand);
   PloinkLine("Stretch",3,49, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",4,0, 45, LandHeight, 1, classLand);
   PloinkLine("Stretch",4,49, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",5,0, 44, LandHeight, 1, classLand);
   PloinkLine("Stretch",5,48, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",6,0, 43, LandHeight, 1, classLand);
   PloinkLine("Stretch",6,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",7,0, 43, LandHeight, 1, classLand);
   PloinkLine("Stretch",7,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",8,0, 42, LandHeight, 1, classLand);
   PloinkLine("Stretch",8,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",9,0, 41, LandHeight, 1, classLand);
   PloinkLine("Stretch",9,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",10,0, 41, LandHeight, 1, classLand);
   PloinkLine("Stretch",10,45, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",11,0, 41, LandHeight, 1, classLand);
   PloinkLine("Stretch",11,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",12,0, 40, LandHeight, 1, classLand);
   PloinkLine("Stretch",12,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",13,0, 39, LandHeight, 1, classLand);
   PloinkLine("Stretch",13,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",14,0, 39, LandHeight, 1, classLand);
   PloinkLine("Stretch",14,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",15,0, 37, LandHeight, 1, classLand);
   PloinkLine("Stretch",15,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",16,0, 36, LandHeight, 1, classLand);
   Ploink("Stretch", 16, 42, LakeHeight, 1, 0, 0, 1);
   PloinkLine("Stretch",16,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",17,0, 35, LandHeight, 1, classLand);
   PloinkLine("Stretch",17,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",18,0, 26, LandHeight, 1, classLand);
   PloinkLine("Stretch",18,30, 34, LandHeight, 1, classLand);
   PloinkLine("Stretch",18,45, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",19,0, 24, LandHeight, 1, classLand);
   PloinkLine("Stretch",19,30, 33, LandHeight, 1, classLand);
   PloinkLine("Stretch",19,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",20,0, 23, LandHeight, 1, classLand);
   PloinkLine("Stretch",20,30, 32, LandHeight, 1, classLand);
   PloinkLine("Stretch",20,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",21,0, 19, LandHeight, 1, classLand);
   PloinkLine("Stretch",21,31, 32, LandHeight, 1, classLand);
   PloinkLine("Stretch",21,36, 36, LandHeight, 1, classLand);
   PloinkLine("Stretch",21,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",22,0, 18, LandHeight, 1, classLand);
   PloinkLine("Stretch",22,36, 37, LandHeight, 1, classLand);
   Ploink("Stretch", 22, 37, LakeHeight, 1, classLand, 0, 2, 0, 1, 0, 1);
   PloinkLine("Stretch",22,44, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",23,0, 15, LandHeight, 1, classLand);
   PloinkLine("Stretch",23,36, 37, LandHeight, 1, classLand);
   PloinkLine("Stretch",23,44, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",24,0, 15, LandHeight, 1, classLand);
   PloinkLine("Stretch",24,30, 30, LandHeight, 1, classLand);
   PloinkLine("Stretch",24,37, 37, LandHeight, 1, classLand);
   PloinkLine("Stretch",24,39, 39, LandHeight, 1, classLand);
   PloinkLine("Stretch",24,43, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",25,0, 15, LandHeight, 1, classLand);
   PloinkLine("Stretch",25,28, 30, LandHeight, 1, classLand);
   PloinkLine("Stretch",25,38, 38, LandHeight, 1, classLand);
   PloinkLine("Stretch",25,42, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",26,0, 16, LandHeight, 1, classLand);
   PloinkLine("Stretch",26,27, 29, LandHeight, 1, classLand);
   PloinkLine("Stretch",26,42, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",27,0, 16, LandHeight, 1, classLand);
   PloinkLine("Stretch",27,28, 28, LandHeight, 1, classLand);
   PloinkLine("Stretch",27,41, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",28,0, 16, LandHeight, 1, classLand);
   PloinkLine("Stretch",28,27, 27, LandHeight, 1, classLand);
   PloinkLine("Stretch",28,34, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",29,0, 15, LandHeight, 1, classLand);
   PloinkLine("Stretch",29,28, 28, LandHeight, 1, classLand);
   PloinkLine("Stretch",29,32, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",30,0, 12, LandHeight, 1, classLand);
   PloinkLine("Stretch",30,27, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",31,0, 10, LandHeight, 1, classLand);
   PloinkLine("Stretch",31,29, 32, LandHeight, 1, classLand);
   PloinkLine("Stretch",31,38, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",32,0, 9, LandHeight, 1, classLand);
   PloinkLine("Stretch",32,27, 29, LandHeight, 1, classLand);
   PloinkLine("Stretch",32,37, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",33,0, 7, LandHeight, 1, classLand);
   PloinkLine("Stretch",33,16, 16, LandHeight, 1, classLand);
   PloinkLine("Stretch",33,20, 20, LandHeight, 1, classLand);
   PloinkLine("Stretch",33,37, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",34,0, 5, LandHeight, 1, classLand);
   PloinkLine("Stretch",34,15, 15, LandHeight, 1, classLand);
   PloinkLine("Stretch",34,19, 25, LandHeight, 1, classLand);
   PloinkLine("Stretch",34,31, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",35,0, 5, LandHeight, 1, classLand);
   PloinkLine("Stretch",35,14, 14, LandHeight, 1, classLand);
   PloinkLine("Stretch",35,20, 27, LandHeight, 1, classLand);
   PloinkLine("Stretch",35,30, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",36,0, 5, LandHeight, 1, classLand);
   PloinkLine("Stretch",36,19, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",37,0, 4, LandHeight, 1, classLand);
   PloinkLine("Stretch",37,23, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",38,0, 2, LandHeight, 1, classLand);
   PloinkLine("Stretch",38,21, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",39,0, 1, LandHeight, 1, classLand);
   PloinkLine("Stretch",39,13, 17, LandHeight, 1, classLand);
   PloinkLine("Stretch",39,22, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",40,0, 1, LandHeight, 1, classLand);
   PloinkLine("Stretch",40,11, 18, LandHeight, 1, classLand);
   PloinkLine("Stretch",40,21, 49, LandHeight, 1, classLand);
   PloinkLine("Stretch",41,0, 1, LandHeight, 1, classLand);
   PloinkLine("Stretch",41,11, 49, LandHeight, 1, classLand);
   PloinkLine("Stretch",42,0, 2, LandHeight, 1, classLand);
   PloinkLine("Stretch",42,6, 6, LandHeight, 1, classLand);
   PloinkLine("Stretch",42,11, 48, LandHeight, 1, classLand);
   PloinkLine("Stretch",43,0, 2, LandHeight, 1, classLand);
   PloinkLine("Stretch",43,6, 6, LandHeight, 1, classLand);
   PloinkLine("Stretch",43,9, 45, LandHeight, 1, classLand);
   PloinkLine("Stretch",44,0, 3, LandHeight, 1, classLand);
   PloinkLine("Stretch",44,8, 44, LandHeight, 1, classLand);
   PloinkLine("Stretch",45,0, 3, LandHeight, 1, classLand);
   PloinkLine("Stretch",45,7, 16, LandHeight, 1, classLand);
   PloinkLine("Stretch",45,21, 44, LandHeight, 1, classLand);
   PloinkLine("Stretch",45,49, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",46,0, 4, LandHeight, 1, classLand);
   PloinkLine("Stretch",46,7, 15, LandHeight, 1, classLand);
   PloinkLine("Stretch",46,21, 43, LandHeight, 1, classLand);
   PloinkLine("Stretch",46,49, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",47,0, 14, LandHeight, 1, classLand);
   PloinkLine("Stretch",47,20, 42, LandHeight, 1, classLand);
   PloinkLine("Stretch",47,47, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",48,0, 14, LandHeight, 1, classLand);
   PloinkLine("Stretch",48,21, 41, LandHeight, 1, classLand);
   PloinkLine("Stretch",48,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",49,0, 14, LandHeight, 1, classLand);
   PloinkLine("Stretch",49,20, 40, LandHeight, 1, classLand);
   PloinkLine("Stretch",49,46, 50, LandHeight, 1, classLand);
   PloinkLine("Stretch",50,0, 14, LandHeight, 1, classLand);
   PloinkLine("Stretch",50,20, 40, LandHeight, 1, classLand);
   PloinkLine("Stretch",50,46, 50, LandHeight, 1, classLand);
   //PloinkLine2("Stretch",0, 0, 50, 0, 25, LandHeight, 1, classLand);

   rmBuildAllAreas();

   PloinkLine2("Mountains",36, 38, 32, 44,  7, CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",32, 42, 28, 44,  7, CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",27, 45, 23, 43,  5, CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",24, 44, 26, 42,  4, CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",35, 38, 31, 42, rmRandInt(4,8), CliffHeight+2, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",25, 45, 26, 46, rmRandInt(2,4), CliffHeight+rmRandInt(2,4), 3, classCliffs);
   PloinkLine2("Mountains",28, 45, 27, 44, rmRandInt(2,4), CliffHeight+rmRandInt(2,4), 3, classCliffs);
   PloinkLine2("Mountains",30, 42, 31, 41, rmRandInt(2,4), CliffHeight+rmRandInt(2,4), 3, classCliffs);
   PloinkLine2("Mountains",34, 40, 35, 39, rmRandInt(2,4), CliffHeight+rmRandInt(2,4), 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",10,  9, 12,  7,  rmRandInt(3,5), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",11,  6, 12,  7,  rmRandInt(4,6), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",13,  7, 14,  7,  rmRandInt(3,5), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",44,  1, 45,  1,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",44,  1, 45,  2,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",48,  4, 49,  5,  rmRandInt(3,4), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",50,  6, 50,  7,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",44,  7, 47,  7,  rmRandInt(3,6), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",44,  8, 46,  7,  rmRandInt(3,6), CliffHeight, 3, classCliffs);

   PloinkLine2("Mountains",42, 28, 44, 26,  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",47, 25, 47, 29,  rmRandInt(4,6), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",44, 26, 47, 25,  rmRandInt(3,5), CliffHeight, 3, classCliffs);
   PloinkLine2("Lake",42, 19, 44, 16,  4, SeaLevel+3, 2);

   PloinkLine2("Mountains",30, 29, 30, 31,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",30, 33, 30, 36,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",29, 28, 30, 28,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",29, 34, 30, 31,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains",42, 14+rmRandInt(0,1), 43, 14,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",42, 12, 43+rmRandInt(0,1), 12,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",45,  9+rmRandInt(0,1), 46,  9,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",45, 11, 46+rmRandInt(0,1), 11,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",45, 13+rmRandInt(0,1), 46, 13,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",45, 15, 46+rmRandInt(0,1), 15,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",46, 10+rmRandInt(0,1), 47, 10,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",46, 12, 47+rmRandInt(0,1), 12,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",48, 11+rmRandInt(0,1), 49, 10,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",48, 13, 49+rmRandInt(0,1), 12,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains",34, 23, 34+rmRandInt(0,1), 24,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",34, 33, 34, 34+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",34, 35, 34+rmRandInt(0,1), 36,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",34, 37, 34, 38+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",34, 39, 34+rmRandInt(0,1), 40,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains",34, 23, 35, 23,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",34, 29, 36, 29,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   PloinkLine2("Mountains",34, 32, 35, 32,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains",35, 21, 35+rmRandInt(0,1), 22,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",35, 24, 35+rmRandInt(0,1), 25,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",35, 26, 35+rmRandInt(0,1), 28,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",35, 30, 35+rmRandInt(0,1), 32,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains",42, 35+rmRandInt(0,1), 43, 35,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",43, 36, 44+rmRandInt(0,1), 35,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",45, 34+rmRandInt(0,1), 46, 34,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",46, 32, 47+rmRandInt(0,1), 31,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();


   PloinkLine2("Mountains",21,  1, 24,  2+rmRandInt(0,1),  rmRandInt(3,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",22,  2, 22+rmRandInt(0,1),  3,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",24,  2, 24,  3+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",22,  4, 23+rmRandInt(0,1),  4,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains", 1, 13,  2+rmRandInt(0,1), 13,  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 2, 13,  2, 15+rmRandInt(0,1),  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 2, 16,  5+rmRandInt(0,1), 16,  rmRandInt(3,5), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 2, 22,  6, 22+rmRandInt(0,1),  rmRandInt(4,6), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 3, 26,  6+rmRandInt(0,1), 26,  rmRandInt(3,5), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 3, 23,  3, 24+rmRandInt(0,1),  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 5, 23,  5+rmRandInt(0,1), 24,  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 7, 23,  8, 24+rmRandInt(0,1),  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 4, 19,  6+rmRandInt(0,1), 19,  rmRandInt(2,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 7, 18,  7, 21+rmRandInt(0,1),  rmRandInt(3,5), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();


   PloinkLine2("Mountains", 0, 48, 10, 40,  25, CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",10, 40, 19, 32,  25, CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 3, 44,  5+rmRandInt(0,1), 44,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 5, 41,  7, 41+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 7, 39,  9+rmRandInt(0,1), 39,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 9, 38, 11, 38+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",11, 37, 13+rmRandInt(0,1), 37,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",13, 36, 15, 36+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",15, 34, 17+rmRandInt(0,1), 34,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",17, 32, 19, 32+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains", 5, 47,  9+rmRandInt(0,1), 45,  rmRandInt(3,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 6, 47,  7, 47+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains", 8, 45,  9+rmRandInt(0,1), 45,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",11, 45, 11, 47+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",11, 46, 14+rmRandInt(0,1), 46,  rmRandInt(3,4), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",15, 47, 16, 46+rmRandInt(0,1),  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",15, 50, 17+rmRandInt(0,1), 45,  rmRandInt(4,6), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

   PloinkLine2("Mountains",20+rmRandInt(0,1), 47, 21, 46,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",21, 48, 22, 48,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();
   PloinkLine2("Mountains",22, 46+rmRandInt(0,1), 23, 47,  rmRandInt(2,3), CliffHeight, 3, classCliffs);
   rmBuildAllAreas();

rmEchoInfo("Resource scaler is " + ResourceScaler);

  LandArea("NooksCranies",50,-5,4,1*cNumberPlayers, classLand, 0, avoidImpassableLandShort, avoidPlayerAreasShort, avoidLakesVeryShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // ASSIGN PLAYER SLOTS BY TEAM -
   int ThisSlot=rmRandInt(4,12); // Random Starting Slot
   int SkipSlot=28/cNumberNonGaiaPlayers;
   for (i=0;<cNumberTeams) {
      for (j=1; <cNumberPlayers) {
         if (rmGetPlayerTeam(j)==i) {
            PloinkPlayer(j,ThisSlot);
            ThisSlot=(ThisSlot+SkipSlot) % 29;
         }
      }
   }

   // TC
   int TownCenterId=rmCreateObjectDef("TownCenter");
   rmAddObjectDefItem(TownCenterId, "Settlement Level 1", 1, 0.0);
   rmAddObjectDefToClass(TownCenterId, classTownCenters);
   rmSetObjectDefMinDistance(TownCenterId, 0.0);
   rmSetObjectDefMaxDistance(TownCenterId, 13.0);
   rmAddObjectDefConstraint(TownCenterId, avoidWaterShort);
   rmPlaceObjectDefPerPlayer(TownCenterId, true);

   int NotTooMuch=iifF(cNumberPlayers>5,2.0,1.0); // IF LOTS OF PLAYERS USE LESS EYE-CANDY/FOOD
   ForestArea("ForestSmall", 10+2*cNumberPlayers,.33*NotTooMuch, classForest, avoidPlayerAreasShort, avoidForestLong, avoidCliffsVeryShort, avoidLakesVeryShort);
   ForestArea("ForestMedium",10+2*cNumberPlayers,.66*NotTooMuch, classForest, avoidPlayerAreasShort, avoidForestMedium, avoidCliffsVeryShort, avoidLakesVeryShort);
   ForestArea("ForestLarge", 10+2*cNumberPlayers,1*NotTooMuch, classForest, avoidPlayerAreasShort, avoidCliffsVeryShort, avoidLakesVeryShort);

   // Settlements
   int SettlementId=rmCreateObjectDef("far settlement");
   rmAddObjectDefItem(SettlementId, "Settlement", 1, 0.0);
   rmAddObjectDefConstraint(SettlementId, avoidForestVeryShort);
   rmAddObjectDefConstraint(SettlementId, avoidMapEdgesShort);
   rmAddObjectDefConstraint(SettlementId, avoidBuildingsLong); // other settlements
   rmSetObjectDefMinDistance(SettlementId, rmZFractionToMeters(.15));
   rmSetObjectDefMaxDistance(SettlementId, rmZFractionToMeters(.25));
   rmPlaceObjectDefPerPlayer(SettlementId, false ,1);
   rmSetObjectDefMinDistance(SettlementId, rmZFractionToMeters(.3));
   rmSetObjectDefMaxDistance(SettlementId, rmZFractionToMeters(.4));
   rmPlaceObjectDefPerPlayer(SettlementId, false ,1);

   // FOOD UP THE MAP - - HerdHuntFishPred
   int HerdFoodGroups=rmRandInt(1,2);
   int HuntFoodGroups=rmRandInt(0,2);
   // REAL CLOSE HERD FOOD
   for(i=1; <=(HerdFoodGroups)) {
      id = CreateAnimals("closeHerd"+i, 1, 15, 18, classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   if (HuntFoodGroups<2) {
      // NEAR HERD FOOD
      for(i=1; <=(HerdFoodGroups)) {
         id = CreateAnimals("nearHerd"+i, 1, rmZFractionToMeters(.2), rmZFractionToMeters(.33), classAnimals, avoidForestMedium);
         rmPlaceObjectDefPerPlayer(id, false, 1);
      }
   }
   // FAR HERD FOOD
   for(i=1; <=HerdFoodGroups/NotTooMuch) {
      id = CreateAnimals("farHerd"+i, 1, rmZFractionToMeters(.33), rmZFractionToMeters(.49), classAnimals, avoidForestMedium, avoidPlayerAreasLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;
   // REAL CLOSE HUNTABLE FOOD
   for(i=1; <=(HuntFoodGroups)) {
      id = CreateAnimals("closeHunt"+i, 2,  15,25, classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   if (HerdFoodGroups<2) {
      // NEAR BY HUNTABLE FOOD
      for(i=1; <=(HuntFoodGroups)) {
         id = CreateAnimals("nearHunt"+i, 2, rmZFractionToMeters(.2), rmZFractionToMeters(.33), classAnimals);
         rmPlaceObjectDefPerPlayer(id, false, 1);
      }
   }
   // FAR AWAY HUNTABLE FOOD
   for(i=1; <=HuntFoodGroups/NotTooMuch) {
      id = CreateAnimals("farHunt"+i, 2, rmZFractionToMeters(.33), rmZFractionToMeters(.495), classAnimals, avoidPlayerAreasLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }

   // NEAR BY PREDATORS
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("nearPredator"+i, 4, rmZFractionToMeters(.15), rmZFractionToMeters(.25), classAnimals, avoidBuildingsLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR AWAY PREDATORS
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("farPredator"+i, 4, rmZFractionToMeters(.25), rmZFractionToMeters(.495), classAnimals, avoidBuildingsLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }

   if (MapSkin!=5) {
      // REAL CLOSE FISHES
      int NumFishes=rmRandInt(7,10) * cNumberPlayers / NotTooMuch;
      id = CreateAnimals("Fish_1", 3, 15, rmXFractionToMeters(0.5), classAnimals);
      rmAddObjectDefConstraint(id, nearShoreLineShort);
      rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, NumFishes);
      id = CreateAnimals("Fish_2", 3, 15, rmZFractionToMeters(0.5), classAnimals);
      rmAddObjectDefConstraint(id, nearShoreLineMedium);
      rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, NumFishes);

      for(i=1; <=cNumberPlayers / NotTooMuch) {
         string str=GetBigFish();
         id=rmCreateObjectDef("bigfish"+str+i);
         rmAddObjectDefItem(id, str, 1, 0.0);
         rmAddObjectDefConstraint(id, avoidLakesVeryShort);
         rmAddObjectDefConstraint(id, avoidMapEdgesShort);
         rmAddObjectDefConstraint(id, avoidLandShoreLineShort);

         rmSetObjectDefMinDistance(id, 0.3);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, cNumberPlayers / NotTooMuch);
         str="Seaweed";
         id=rmCreateObjectDef("weed"+str+i);
         rmAddObjectDefItem(id, str, 3, 2.0);
         rmAddObjectDefConstraint(id, nearLandShort);
         rmAddObjectDefConstraint(id, avoidLakesVeryShort);
         rmSetObjectDefMinDistance(id, 0.3);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, cNumberPlayers * 5 / NotTooMuch);
      }
   }
   // GOLD IN THE HILLS
   CreateGold(6000, rmZFractionToMeters(.07), 3000 / NotTooMuch, rmZFractionToMeters(.3), 3000 / NotTooMuch, rmZFractionToMeters(.5)); // 3 Amount & Distances
   // Relics
   int RelicId=rmCreateObjectDef("relic");
   rmAddObjectDefItem(RelicId, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(RelicId, rmZFractionToMeters(.25));
   rmSetObjectDefMaxDistance(RelicId, rmZFractionToMeters(.45));
   rmAddObjectDefConstraint(RelicId, avoidRelicLong);
   rmAddObjectDefConstraint(RelicId, avoidAllShort);
   rmPlaceObjectDefPerPlayer(RelicId, false, rmRandInt(1,2));
   // Various Rocks
   AddRocks(5*cNumberPlayers, avoidAllVeryShort, avoidPlayerAreasShort);
   rmSetStatusText("",pct);
   RandomTrees();
   pct = pct-0.05;

  // **** TRIGGERS ****
   GameEgg("TOS_Mediterranean v1.0");
}

